<?php 
/**
 * Module Name: IPB To PunBB
 * Version: 0.1
 * Author: PunBB.INFO
**/

if (!defined('FORUM')) die();

require $forum_url['pan_converter_modules'].'/'.$section.'/functions.php';

$errors = array();

if (isset($_POST['convert']) )
{
	$dump_name = $_POST['dump_name'];
	$prefix = !empty($_POST['prefix']) ? forum_trim($_POST['prefix']) : '';
	
	$list_tables = array(
		'forums',
		'groups',
		'members',
		'posts',
		'topics',
	);
	
	if (file_exists(FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name) && ($prefix != ''))
	{
		$dump_path = FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name;
		
		$fp = file_get_contents($dump_path);
		
		foreach ($list_tables as $table_name)
		{
			$old_name = '$'.$prefix.$table_name.' = array';
			$new_name = '$punbb_'.$table_name.' = array';
			$fp = str_replace($old_name, $new_name, $fp);
		}
		
		file_put_contents($dump_path, $fp);
	}

/*
	//Проверить список всех переменных
	if (stristr($fp, '.$punbb_groups = array') === false) $errors[] = 'Table GROUPS not found!';
	else if (stristr($fp, '.$punbb_members = array') === false) $errors[] = 'Table MEMBERS not found!';
	else if (stristr($fp, '.$punbb_posts = array') === false) $errors[] = 'Table POSTS not found!';
	else if (stristr($fp, '.$punbb_topics = array') === false) $errors[] = 'Table TOPICS not found!';
	else if (stristr($fp, '.$punbb_forums = array') === false) $errors[] = 'Table FORUMS not found!';
*/
	
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array('Converter', forum_link($forum_url['pan_converter_settings'])),
		'From phpBB to PunBB'
	);

	define('FORUM_PAGE_SECTION', 'pan-converter');
	define('FORUM_PAGE', 'admin-pan-converter-'.$section);
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

?>

	<div class="main-content main-frm">

		<div class="content-head">
			<h2 class="hn"><span>Converting phpBB-3 to PunBB-1.4</span></h2>
		</div>

<?php
	// If there were any errors, show them
	if (!empty($errors))
	{
		$forum_page['errors'] = array();
		foreach ($errors as $cur_error)
			$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
			
?>
		<div class="ct-box error-box">
			<h2 class="warn hn">Errors!</h2>
			<ul class="error-list">
				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
			</ul>
		</div>
<?php
	}
?>

		<div class="frm-form">
			<div class="ct-box">
				<p><strong>Notice!</strong></p>
				<p>To start the conversion, click the button. Attention, depending on the size of the database file, the browser may hang. After starting the converter, do not update the page of your browser and do not wait for the end of the session.</p>
			</div>
		</div>

		<form class="frm-form" name="upload" action="<?php echo forum_link($forum_url['pan_converter_section'], $section) ?>" method="post">

			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_section'], $section)) ?>" />
				<input type="hidden" name="dump_name" value="<?php echo $dump_name ?>" />
				<input type="hidden" name="prefix" value="<?php echo $prefix ?>" />
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary caution"><input type="submit" name="confirm" value="Confirm Сonversion!" /></span>
			</div>
		</form>

	</div>

<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
	
}
else if (isset($_POST['confirm']) )
{
	$dump_name = $_POST['dump_name'];
	$prefix = forum_trim($_POST['prefix']);
	
	//
	if (file_exists(FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name))
		require FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name;
	
	//SET DEFAULT TABLES
	if (isset($groups)) $punbb_groups = $groups;
	if (isset($members)) $punbb_members = $members;
	if (isset($posts)) $punbb_posts = $posts;
	if (isset($topics)) $punbb_topics = $topics;
	if (isset($forums)) $punbb_topics = $forums;
	
	
	//VALIDATE ALL TABLES
	if (!isset($punbb_groups)) $errors[] = 'Table GROUPS not found!';
	else if (!isset($punbb_members)) $errors[] = 'Table MEMBERS not found!';
	else if (!isset($punbb_posts)) $errors[] = 'Table POSTS not found!';
	else if (!isset($punbb_topics)) $errors[] = 'Table TOPICS not found!';
	else if (!isset($punbb_forums)) $errors[] = 'Table FORUMS not found!';
	
	
	if (empty($errors))
	{
		$forum_punbb = array();
		$forum_punbb['groups'] = array();
		$forum_punbb['result'] = array();
		
		foreach ($punbb_groups as $groups)
		{
			//SET DEFAULT GROUPS
			
			//GUESTS
			if ($groups['g_id'] == 2)
				$group_id = 2;
			//REGISTERED
			else if ($groups['g_id'] == 3)
				$group_id = 3;
			//ADMINISTRATORS
			else if ($groups['g_id'] == 4)
				$group_id = 1;
			//BANNED
//			else if ($groups['g_id'] == 5)
//				$group_id = 0;
			//MODERATORS
			else if ($groups['g_id'] == 6)
				$group_id = 4;
			//UNACTIVE
//			else if ($groups['g_id'] == 1)
//				$group_id = 0;
			else
				$group_id = 3;
			
			$forum_punbb['groups'][$groups['g_id']] = $group_id;
		}
		
echo '<pre>';
//print_r($forum_punbb['groups']);
echo '</pre>';
		
		//DELETE ALL USERS
		$query = array(
			'DELETE'	=> 'users',
			'WHERE'		=> 'id!=1 AND id!=2'
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_punbb['result']['users'] = 0;
		foreach ($punbb_members as $users)
		{
			//UPDATE GLOBAL ADMIN PROFILE
			if ($users['member_id'] == 1)
			{
				$query = array(
					'UPDATE'	=> 'users',
					'SET'		=> 'username=\''.$forum_db->escape($users['name']).'\'',
					'WHERE'		=> 'id=2 AND group_id=1'
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
			}
			
			//VALIDE EACH USER
			$query = array(
				'SELECT'	=> 'id',
				'FROM'		=> 'users',
				'WHERE'		=> 'id='.$users['member_id']
			);
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$cur_uid = $forum_db->fetch_assoc($result);
			
			if (count($cur_uid) < 1)
			{
				$user_group_id = $forum_punbb['groups'][$users['member_group_id']];
				
				if ($users['language'] == '1') $user_lang = 'Russian';
				else $user_lang = 'English';
				
				
				if (file_exists(FORUM_ROOT.'lang/'.$user_lang.'/index.php'))
					$user_lang = $user_lang;
				else
					$user_lang = 'English';
				
				
				$query = array(
					'INSERT'	=> 'id, group_id, username, password, salt, email, registered, registration_ip, last_visit, language, num_posts',
					'INTO'		=> 'users',
					'VALUES'	=> ''.$users['member_id'].', '.$user_group_id.', \''.$forum_db->escape($users['name']).'\', \''.$forum_db->escape($users['members_pass_hash']).'\', \''.$forum_db->escape($users['members_pass_salt']).'\', \''.$forum_db->escape($users['email']).'\', '.$users['joined'].', \''.$forum_db->escape($users['ip_address']).'\', '.$users['last_visit'].', \''.$forum_db->escape($user_lang).'\', '.$users['posts'],
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);

				$forum_punbb['result']['users']++;
			}
		}
		
		
		//DELETE ALL CATEGORIES
		$query = array(
			'DELETE'	=> 'categories',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_punbb['result']['categories'] = 0;
		foreach ($punbb_forums as $forums)
		{
			if ($forums['parent_id'] == '-1')
			{
				// Add the category
				$query = array(
					'INSERT'	=> 'id, cat_name, disp_position',
					'INTO'		=> 'categories',
					'VALUES'	=> ''.$forums['id'].', \''.$forum_db->escape($forums['name']).'\', '.$forums['position']
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);

				$forum_punbb['result']['categories']++;
			}
		}
		
		
		
		//DELETE ALL FORUMS
		$query = array(
			'DELETE'	=> 'forums',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_punbb['result']['forums'] = 0;
		foreach ($punbb_forums as $forums)
		{
			if ($forums['parent_id'] > 0)
			{
				$last_post = ($forums['last_post'] > 0) ? $forums['last_post'] : 'NULL';
				
				// Add the forum
				$query = array(
					'INSERT'	=> 'id, forum_name, forum_desc, last_post, last_post_id, last_poster, cat_id',
					'INTO'		=> 'forums',
					'VALUES'	=> ''.$forums['id'].', \''.$forum_db->escape($forums['name']).'\', \''.$forum_db->escape($forums['description']).'\', \''.$forum_db->escape($last_post).'\', \''.$forum_db->escape($forums['last_id']).'\', \''.$forum_db->escape($forums['last_poster_name']).'\', '.$forums['parent_id'].''
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				$new_uid = $forum_db->insert_id();
				
				$forum_punbb['result']['forums']++;

				sync_forum($new_uid);
			}
		}
		
		
		//DELETE ALL TOPICS
		$query = array(
			'DELETE'	=> 'topics',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_punbb['result']['topics'] = 0;
		foreach ($punbb_topics as $topics)
		{
			// Add the topic
			$query = array(
				'INSERT'	=> 'id, poster, subject, posted, first_post_id, last_post, last_poster, num_views, forum_id',
				'INTO'		=> 'topics',
				'VALUES'	=> ''.$topics['tid'].', \''.$forum_db->escape($topics['starter_name']).'\', \''.$forum_db->escape($topics['title']).'\', '.$topics['start_date'].', '.$topics['topic_firstpost'].', '.$topics['last_post'].', \''.$forum_db->escape($topics['last_poster_name']).'\', '.$topics['views'].', '.$topics['forum_id']
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			sync_forum($topics['forum_id']);
			
			$forum_punbb['result']['topics']++;
		}
		
		
		
		//DELETE ALL POSTS
		$query = array(
			'DELETE'	=> 'posts',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_punbb['result']['posts'] = 0;
		foreach ($punbb_posts as $posts)
		{
			if ($posts['author_id'] == 0) $poster_id = 1;
			else if ($posts['author_id'] == 1) $poster_id = 2;
			else $poster_id = $posts['author_id'];
			
			$message = pan_converter_strip_tags($posts['post']);
			
			// Add the post
			$query = array(
				'INSERT'	=> 'id, poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id',
				'INTO'		=> 'posts',
				'VALUES'	=> ''.$posts['pid'].', \''.$forum_db->escape($posts['author_name']).'\', '.$poster_id.', \''.$forum_db->escape($posts['ip_address']).'\', \''.$forum_db->escape($message).'\', '.$posts['use_emo'].', '.$posts['post_date'].', '.$posts['topic_id']
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			$new_pid = $forum_db->insert_id();
			
			$query = array(
				'SELECT'	=> 't.forum_id',
				'FROM'		=> 'topics AS t',
				'WHERE'		=> 't.id='.$posts['topic_id']
			);
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$topic_info = $forum_db->fetch_assoc($result);
			
			// Count number of replies in the topic
			$query = array(
				'SELECT'	=> 'COUNT(p.id)',
				'FROM'		=> 'posts AS p',
				'WHERE'		=> 'p.topic_id='.$posts['topic_id']
			);
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$num_replies = $forum_db->result($result, 0) - 1;
			
			// Update topic
			$query = array(
				'UPDATE'	=> 'topics',
				'SET'		=> 'num_replies='.$num_replies.', last_post='.$posts['post_date'].', last_post_id='.$new_pid.', last_poster=\''.$forum_db->escape($posts['author_name']).'\'',
				'WHERE'		=> 'id='.$posts['topic_id']
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			sync_forum($topic_info['forum_id']);
			
			if (!defined('FORUM_SEARCH_IDX_FUNCTIONS_LOADED'))
				require FORUM_ROOT.'include/search_idx.php';
			
			update_search_index('post', $new_pid, $message);
			
			$forum_punbb['result']['posts']++;
		}
		
		
		
		//NEXT TEBLE HERE
		
		
		
	}
	
	$forum_flash->add_info('All tables converted!');
	redirect(forum_link($forum_url['pan_converter_section'], $section), '');
}
else
{
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array('Converter', forum_link($forum_url['pan_converter_settings'])),
		'From phpBB to PunBB'
	);

	define('FORUM_PAGE_SECTION', 'pan-converter');
	define('FORUM_PAGE', 'admin-pan-converter-'.$section);
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

?>

	<div class="main-content main-frm">

		<div class="content-head">
			<h2 class="hn"><span>Converting phpBB-3 to PunBB-1.4</span></h2>
		</div>

<?php
	// If there were any errors, show them
	if (!empty($errors))
	{
		$forum_page['errors'] = array();
		foreach ($errors as $cur_error)
			$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
			
?>
		<div class="ct-box error-box">
			<h2 class="warn hn">Errors!</h2>
			<ul class="error-list">
				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
			</ul>
		</div>
<?php
	}
?>

		<div class="frm-form">
			<div class="ct-box">
				<p><strong>Notice!</strong></p>
				<p>Select the database dump, then enter the table prefix that you used when installing your IPB forum.</p>
				<p>If the prefix was not used, just leave the field blank and start the conversion wizard.</p>
			</div>
		</div>

		<form class="frm-form" name="upload" action="<?php echo forum_link($forum_url['pan_converter_section'], $section) ?>" method="post">

			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_section'], $section)) ?>" />
			</div>

			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld">
						<span>Dump Files</span>
						<small>Select a SQL Dump as PHP Array file.</small>
					</label><br />
					<span class="fld-input"><select name="dump_name">
<?php
	$available_files = pan_get_all_files(FORUM_ROOT.$forum_url['pan_converter_dumps'], array('php'));
	foreach ($available_files as $sql_files) {
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$sql_files.'">'.$sql_files.'</option>'."\n";
	}
?>
						</select>
					</span>
				</div>
			</div>
			
			<div class="sf-set set">
				<div class="sf-box text required longtext">
					<label for="fld"><span>Prefix Tables</span><small>Enter prefix of tables selected database.</small></label><br />
					<span class="fld-input"><input type="text" name="prefix" value="" placeholder="prefix_" /></span>
				</div>
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="convert" value="Start" /></span>
			</div>
		</form>

	</div>

<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
}
